Index: issm/trunk/src/c/classes/Hook.cpp
===================================================================
--- issm/trunk/src/c/classes/Hook.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Hook.cpp	(revision 18301)
@@ -16,6 +16,5 @@
 
 /*Constructor/Destructors*/
-/*FUNCTION Hook::Hook(){{{*/
-Hook::Hook(){
+Hook::Hook(){/*{{{*/
 	this->num     = 0;
 	this->objects = NULL;
@@ -24,6 +23,5 @@
 }
 /*}}}*/
-/*FUNCTION Hook::Hook(int* ids, int num){{{*/
-Hook::Hook(int* in_ids, int in_num){
+Hook::Hook(int* in_ids, int in_num){/*{{{*/
 
 	/*Get number of objects to hook*/
@@ -31,15 +29,16 @@
 
 	/*Get out if num=0*/
-	if (num==0){
+	if (this->num<=0){
 		/*Empty hook*/
 		this->ids     = NULL;
 		this->objects = NULL;
 		this->offsets = NULL;
+		this->num = 0;
 	}
 	else{
 		/*Allocate: */
-		this->objects=xNew<Object*>(this->num);
-		this->ids=xNew<int>(this->num);
-		this->offsets=xNew<int>(this->num);
+		this->objects=xNew<Object*>(in_num);
+		this->ids=xNew<int>(in_num);
+		this->offsets=xNew<int>(in_num);
 
 		/*Copy ids: */
@@ -52,6 +51,5 @@
 }
 /*}}}*/
-/*FUNCTION Hook::~Hook(){{{*/
-Hook::~Hook(){
+Hook::~Hook(){/*{{{*/
 	xDelete<Object*>(this->objects);
 	xDelete<int>(this->ids);
@@ -61,6 +59,5 @@
 
 /*Some of the Object functionality: */
-/*FUNCTION Hook::Echo{{{*/
-void Hook::Echo(void){
+void Hook::Echo(void){/*{{{*/
 	_assert_(this);
 	int i;
@@ -80,6 +77,5 @@
 }
 /*}}}*/
-/*FUNCTION Hook::DeepEcho{{{*/
-void Hook::DeepEcho(void){
+void Hook::DeepEcho(void){/*{{{*/
 
 	int i;
@@ -108,6 +104,5 @@
 }
 /*}}}*/
-/*FUNCTION Hook::copy {{{*/
-Object* Hook::copy(void){
+Object* Hook::copy(void){/*{{{*/
 
 	/*output: */
@@ -115,18 +110,9 @@
 
 	/*initalize output: */
-	output=new Hook();
-
-	/*copy in the fields: */
-	output->num=this->num;
-	if(output->num){
-		output->objects = xNew<Object*>(output->num);
-		output->ids     = xNew<int>(output->num);
-		output->offsets = xNew<int>(output->num);
-	}
+	output=new Hook(this->ids,this->num);
 
 	for(int i=0;i<output->num;i++){
 		output->objects[i] = this->objects[i];
 		output->offsets[i] = this->offsets[i];
-		output->ids[i]     = this->ids[i];
 	}
 
@@ -136,6 +122,16 @@
 
 /*Hook management: */
-/*FUNCTION Hook::configure{{{*/
-void Hook::configure(DataSet* dataset){
+void Hook::reset(){/*{{{*/
+
+	/*intermediary: */
+	Object* object=NULL;
+	int i;
+
+	for(i=0;i<this->num;i++){
+			this->objects[i]=NULL; //reset this node.
+	}
+}
+/*}}}*/
+void Hook::configure(DataSet* dataset){/*{{{*/
 
 	/*intermediary: */
@@ -168,4 +164,5 @@
 			else this->offsets[i]=UNDEF; //object offset was wrong, reset it.
 		}
+		else this->offsets[i]=UNDEF;
 
 		/*Now, for this->objects that did not get resolved, and for which we have no offset, chase them in the dataset, by id: */
@@ -178,9 +175,8 @@
 }
 /*}}}*/
-/*FUNCTION Hook::delivers{{{*/
-Object* Hook::delivers(void){
+Object* Hook::delivers(void){/*{{{*/
 
 	/*first, check that we only have one T object in our object list: */
-	if (this->num!=1) _error_("trying to delivery a single hook object when hook holds " << this->num << " objects" << "\n");
+	if (this->num!=1) _error_("trying to deliver a single hook object when hook holds " << this->num << " objects" << "\n");
 
 	/*check NULL: */
@@ -191,21 +187,17 @@
 
 /*}}}*/
-/*FUNCTION Hook::deliverp{{{*/
-Object** Hook::deliverp(void){
+Object** Hook::deliverp(void){/*{{{*/
 	return objects;
 }
 /*}}}*/
-/*FUNCTION Hook::Ids{{{*/
-int* Hook::Ids(void){
+int* Hook::Ids(void){/*{{{*/
 	return this->ids;
 }
 /*}}}*/
-/*FUNCTION Hook::GetNum{{{*/
-int Hook::GetNum(void){
+int Hook::GetNum(void){/*{{{*/
 	return this->num;
 }
 /*}}}*/
-/*FUNCTION Hook::Spawn{{{*/
-Hook* Hook::Spawn(int* indices, int numindices){
+Hook* Hook::Spawn(int* indices, int numindices){/*{{{*/
 
 	/*output: */
Index: issm/trunk/src/c/classes/Hook.h
===================================================================
--- issm/trunk/src/c/classes/Hook.h	(revision 18081)
+++ issm/trunk/src/c/classes/Hook.h	(revision 18301)
@@ -39,4 +39,5 @@
 		Object**   deliverp(void); //deliver all objects
 		void       configure(DataSet* dataset);
+		void       reset(void);
 		Hook*      Spawn(int* indices, int numindices);
 		int*       Ids(void);
Index: issm/trunk/src/c/classes/IndependentObject.cpp
===================================================================
--- issm/trunk/src/c/classes/IndependentObject.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/IndependentObject.cpp	(revision 18301)
@@ -14,6 +14,5 @@
 
 /*IndependentObject constructors and destructor*/
-/*FUNCTION IndependentObject::IndependentObject(){{{*/
-IndependentObject::IndependentObject(){
+IndependentObject::IndependentObject(){/*{{{*/
 	this->name=NoneEnum;
 	this->type=0;
@@ -21,6 +20,5 @@
 }
 /*}}}*/
-/*FUNCTION IndependentObject::IndependentObject(int in_name, int in_type){{{*/
-IndependentObject::IndependentObject(int in_name, int in_type){
+IndependentObject::IndependentObject(int in_name, int in_type){/*{{{*/
 
 	this->numberofindependents=0;
@@ -31,12 +29,10 @@
 }
 /*}}}*/
-/*FUNCTION IndependentObject::~IndependentObject() {{{*/
-IndependentObject::~IndependentObject(){ //destructor
+IndependentObject::~IndependentObject(){ //destructor/*{{{*/
 }
 /*}}}*/
 
 /*Object virtual functions definitions:*/
-/*FUNCTION IndependentObject::Echo{{{*/
-void IndependentObject::Echo(void){
+void IndependentObject::Echo(void){/*{{{*/
 
 	_printf_("IndependentObject:\n");
@@ -51,14 +47,11 @@
 }
 /*}}}*/
-/*FUNCTION IndependentObject::DeepEcho{{{*/
-void IndependentObject::DeepEcho(void){
+void IndependentObject::DeepEcho(void){/*{{{*/
 	this->Echo();
 }
 /*}}}*/
-/*FUNCTION IndependentObject::Id{{{*/
-int    IndependentObject::Id(void){ return -1; }
+int    IndependentObject::Id(void){ return -1; }/*{{{*/
 /*}}}*/
-/*FUNCTION IndependentObject::ObjectEnum{{{*/
-int IndependentObject::ObjectEnum(void){
+int IndependentObject::ObjectEnum(void){/*{{{*/
 
 	return IndependentObjectEnum;
@@ -66,6 +59,5 @@
 }
 /*}}}*/
-/*FUNCTION IndependentObject::copy{{{*/
-Object* IndependentObject::copy(void) { 
+Object* IndependentObject::copy(void) { /*{{{*/
 
 	IndependentObject* object=new IndependentObject();
@@ -78,6 +70,5 @@
 
 /*IndependentObject methods: */
-/*FUNCTION IndependentObject::FetchIndependent{{{*/
-void IndependentObject::FetchIndependent(IoModel* iomodel){
+void IndependentObject::FetchIndependent(IoModel* iomodel){/*{{{*/
 
 	int my_rank;
@@ -183,12 +174,10 @@
 }
 /*}}}*/
-/*FUNCTION IndependentObject::NumIndependents{{{*/
-int  IndependentObject::NumIndependents(void){
+int  IndependentObject::NumIndependents(void){/*{{{*/
 
 	return this->numberofindependents;;
 }
 /*}}}*/
-/*FUNCTION IndependentObject::FillIndependents{{{*/
-void IndependentObject::FillIndependents(IssmDouble** data, IssmDouble* xp){
+void IndependentObject::FillIndependents(IssmDouble** data, IssmDouble* xp){/*{{{*/
 
 	int i;
Index: issm/trunk/src/c/classes/Inputs/BoolInput.cpp
===================================================================
--- issm/trunk/src/c/classes/Inputs/BoolInput.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Inputs/BoolInput.cpp	(revision 18301)
@@ -13,11 +13,9 @@
 
 /*BoolInput constructors and destructor*/
-/*FUNCTION BoolInput::BoolInput(){{{*/
-BoolInput::BoolInput(){
+BoolInput::BoolInput(){/*{{{*/
 	return;
 }
 /*}}}*/
-/*FUNCTION BoolInput::BoolInput(int in_enum_type,bool in_value){{{*/
-BoolInput::BoolInput(int in_enum_type,bool in_value){
+BoolInput::BoolInput(int in_enum_type,bool in_value){/*{{{*/
 
 	enum_type=in_enum_type;
@@ -25,6 +23,5 @@
 }
 /*}}}*/
-/*FUNCTION BoolInput::~BoolInput(){{{*/
-BoolInput::~BoolInput(){
+BoolInput::~BoolInput(){/*{{{*/
 	return;
 }
@@ -32,20 +29,16 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION BoolInput::Echo {{{*/
-void BoolInput::Echo(void){
+void BoolInput::Echo(void){/*{{{*/
 	this->DeepEcho();
 }
 /*}}}*/
-/*FUNCTION BoolInput::DeepEcho{{{*/
-void BoolInput::DeepEcho(void){
+void BoolInput::DeepEcho(void){/*{{{*/
 
 	_printf_(setw(15)<<"   BoolInput "<<setw(25)<<left<<EnumToStringx(this->enum_type)<<" "<<(value?"true":"false") << "\n");
 }
 /*}}}*/
-/*FUNCTION BoolInput::Id{{{*/
-int    BoolInput::Id(void){ return -1; }
+int    BoolInput::Id(void){ return -1; }/*{{{*/
 /*}}}*/
-/*FUNCTION BoolInput::ObjectEnum{{{*/
-int BoolInput::ObjectEnum(void){
+int BoolInput::ObjectEnum(void){/*{{{*/
 
 	return BoolInputEnum;
@@ -53,6 +46,5 @@
 }
 /*}}}*/
-/*FUNCTION BoolInput::copy{{{*/
-Object* BoolInput::copy() {
+Object* BoolInput::copy() {/*{{{*/
 
 	return new BoolInput(this->enum_type,this->value);
@@ -62,6 +54,5 @@
 
 /*BoolInput management*/
-/*FUNCTION BoolInput::InstanceEnum{{{*/
-int BoolInput::InstanceEnum(void){
+int BoolInput::InstanceEnum(void){/*{{{*/
 
 	return this->enum_type;
@@ -69,6 +60,5 @@
 }
 /*}}}*/
-/*FUNCTION BoolInput::SpawnTriaInput{{{*/
-Input* BoolInput::SpawnTriaInput(int index1,int index2,int index3){
+Input* BoolInput::SpawnTriaInput(int index1,int index2,int index3){/*{{{*/
 
 		/*output*/
@@ -84,6 +74,5 @@
 }
 /*}}}*/
-/*FUNCTION BoolInput::SpawnSegInput{{{*/
-Input* BoolInput::SpawnSegInput(int index1,int index2){
+Input* BoolInput::SpawnSegInput(int index1,int index2){/*{{{*/
 
 		/*output*/
@@ -101,36 +90,28 @@
 
 /*Object functions*/
-/*FUNCTION BoolInput::GetInputValue(bool* pvalue) {{{*/
-void BoolInput::GetInputValue(bool* pvalue){
+void BoolInput::GetInputValue(bool* pvalue){/*{{{*/
 	*pvalue=value;
 }
 /*}}}*/
-/*FUNCTION BoolInput::GetInputValue(int* pvalue){{{*/
-void BoolInput::GetInputValue(int* pvalue){_error_("not supported yet!");}
+void BoolInput::GetInputValue(int* pvalue){_error_("not supported yet!");}/*{{{*/
 /*}}}*/
-/*FUNCTION BoolInput::GetInputValue(IssmDouble* pvalue){{{*/
-void BoolInput::GetInputValue(IssmDouble* pvalue){_error_("not supported yet!");}
+void BoolInput::GetInputValue(IssmDouble* pvalue){_error_("not supported yet!");}/*{{{*/
 /*}}}*/
-/*FUNCTION BoolInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){{{*/
-void BoolInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){_error_("not supported yet!");}
+void BoolInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){_error_("not supported yet!");}/*{{{*/
 /*}}}*/
-/*FUNCTION BoolInput::ChangeEnum{{{*/
-void BoolInput::ChangeEnum(int newenumtype){
+void BoolInput::ChangeEnum(int newenumtype){/*{{{*/
 	this->enum_type=newenumtype;
 }
 /*}}}*/
-/*FUNCTION BoolInput::SquareMin{{{*/
-void BoolInput::SquareMin(IssmDouble* psquaremin,Parameters* parameters){
+void BoolInput::SquareMin(IssmDouble* psquaremin,Parameters* parameters){/*{{{*/
 	/*square of a bool is the bool itself: */
 	*psquaremin=value;
 }
 /*}}}*/
-/*FUNCTION BoolInput::Scale{{{*/
-void BoolInput::Scale(IssmDouble scale_factor){
+void BoolInput::Scale(IssmDouble scale_factor){/*{{{*/
 	/*a bool cannot be scaled: */
 }
 /*}}}*/
-/*FUNCTION BoolInput::AXPY{{{*/
-void BoolInput::AXPY(Input* xinput,IssmDouble scalar){
+void BoolInput::AXPY(Input* xinput,IssmDouble scalar){/*{{{*/
 
 	BoolInput*  xboolinput=NULL;
@@ -152,6 +133,5 @@
 }
 /*}}}*/
-/*FUNCTION BoolInput::Extrude{{{*/
-void BoolInput::Extrude(void){
+void BoolInput::Extrude(void){/*{{{*/
 
 	/*do nothing*/
@@ -159,6 +139,5 @@
 }
 /*}}}*/
-/*FUNCTION BoolInput::GetVectorFromInputs{{{*/
-void BoolInput::GetVectorFromInputs(Vector<IssmDouble>* vector,int* doflist){
+void BoolInput::GetVectorFromInputs(Vector<IssmDouble>* vector,int* doflist){/*{{{*/
 
 	_error_("not supporte yet!");
@@ -166,6 +145,5 @@
 }
 /*}}}*/
-/*FUNCTION BoolInput::Configure{{{*/
-void BoolInput::Configure(Parameters* parameters){
+void BoolInput::Configure(Parameters* parameters){/*{{{*/
 	/*do nothing: */
 }
Index: issm/trunk/src/c/classes/Inputs/ControlInput.cpp
===================================================================
--- issm/trunk/src/c/classes/Inputs/ControlInput.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Inputs/ControlInput.cpp	(revision 18301)
@@ -13,6 +13,5 @@
 
 /*ControlInput constructors and destructor*/
-/*FUNCTION ControlInput::ControlInput(){{{*/
-ControlInput::ControlInput(){
+ControlInput::ControlInput(){/*{{{*/
 	control_id  = 0;
 	values      = NULL;
@@ -23,6 +22,5 @@
 }
 /*}}}*/
-/*FUNCTION ControlInput::ControlInput(int enum_type,int enum_input,IssmDouble* pvalues,IssmDouble* pmin,IssmDouble* pmax,int id){{{*/
-ControlInput::ControlInput(int in_enum_type,int enum_input,IssmDouble* pvalues,IssmDouble* pmin,IssmDouble* pmax,int id){
+ControlInput::ControlInput(int in_enum_type,int enum_input,IssmDouble* pvalues,IssmDouble* pmin,IssmDouble* pmax,int id){/*{{{*/
 
 	control_id=id;
@@ -48,6 +46,5 @@
 }
 /*}}}*/
-/*FUNCTION ControlInput::~ControlInput(){{{*/
-ControlInput::~ControlInput(){
+ControlInput::~ControlInput(){/*{{{*/
 	delete values;
 	delete savedvalues;
@@ -59,11 +56,9 @@
 
 /*Object virtual functions definitions:*/
-		/*FUNCTION ControlInput::Echo {{{*/
-void ControlInput::Echo(void){
+void ControlInput::Echo(void){/*{{{*/
 	this->DeepEcho();
 }
 /*}}}*/
-/*FUNCTION ControlInput::DeepEcho{{{*/
-void ControlInput::DeepEcho(void){
+void ControlInput::DeepEcho(void){/*{{{*/
 
 	_printf_("ControlInput:\n");
@@ -76,9 +71,7 @@
 }
 /*}}}*/
-/*FUNCTION ControlInput::Id{{{*/
-int    ControlInput::Id(void){ return -1; }
-/*}}}*/
-/*FUNCTION ControlInput::ObjectEnum{{{*/
-int ControlInput::ObjectEnum(void){
+int    ControlInput::Id(void){ return -1; }/*{{{*/
+/*}}}*/
+int ControlInput::ObjectEnum(void){/*{{{*/
 
 	return ControlInputEnum;
@@ -86,6 +79,5 @@
 }
 /*}}}*/
-/*FUNCTION ControlInput::copy{{{*/
-Object* ControlInput::copy() {
+Object* ControlInput::copy() {/*{{{*/
 
 	ControlInput* output=NULL;
@@ -106,6 +98,5 @@
 
 /*ControlInput management*/
-/*FUNCTION ControlInput::InstanceEnum{{{*/
-int ControlInput::InstanceEnum(void){
+int ControlInput::InstanceEnum(void){/*{{{*/
 
 	return this->enum_type;
@@ -115,10 +106,8 @@
 
 /*Object functions*/
-/*FUNCTION ControlInput::AXPY(){{{*/
-void ControlInput::AXPY(Input* xinput,IssmDouble scalar){
+void ControlInput::AXPY(Input* xinput,IssmDouble scalar){/*{{{*/
 	values->AXPY(xinput,scalar);
 }/*}}}*/
-/*FUNCTION ControlInput::Constrain(){{{*/
-void ControlInput::Constrain(void){
+void ControlInput::Constrain(void){/*{{{*/
 
 	Input* newvalues=NULL;
@@ -129,16 +118,13 @@
 	delete values; this->values=newvalues;
 }/*}}}*/
-/*FUNCTION ControlInput::Constrain(IssmDouble min, IssmDouble max){{{*/
-void ControlInput::Constrain(IssmDouble min, IssmDouble max){
+void ControlInput::Constrain(IssmDouble min, IssmDouble max){/*{{{*/
 	   values->Constrain(min,max);
 }/*}}}*/
-/*FUNCTION ControlInput::Extrude{{{*/
-void ControlInput::Extrude(void){
+void ControlInput::Extrude(void){/*{{{*/
 	values->Extrude();
 	savedvalues->Extrude();
 	//gradient->Extrude();
 }/*}}}*/
-/*FUNCTION ControlInput::GetResultInterpolation{{{*/
-int  ControlInput::GetResultInterpolation(void){
+int  ControlInput::GetResultInterpolation(void){/*{{{*/
 
 	return values->GetResultInterpolation();
@@ -146,6 +132,5 @@
 }
 /*}}}*/
-/*FUNCTION ControlInput::GetResultNumberOfNodes{{{*/
-int  ControlInput::GetResultNumberOfNodes(void){
+int  ControlInput::GetResultNumberOfNodes(void){/*{{{*/
 
 	return values->GetResultNumberOfNodes();
@@ -153,15 +138,12 @@
 }
 /*}}}*/
-/*FUNCTION ControlInput::GetGradient{{{*/
-void ControlInput::GetGradient(Vector<IssmDouble>* gradient_vec,int* doflist){
+void ControlInput::GetGradient(Vector<IssmDouble>* gradient_vec,int* doflist){/*{{{*/
 	if(gradient) gradient->GetVectorFromInputs(gradient_vec,doflist);
 }/*}}}*/
-/*FUNCTION ControlInput::ScaleGradient{{{*/
-void ControlInput::ScaleGradient(IssmDouble scaling_factor){
+void ControlInput::ScaleGradient(IssmDouble scaling_factor){/*{{{*/
 	if(!gradient) _error_("Gradient of ControlInput " << EnumToStringx(enum_type) << " not found");
 	gradient->Scale(scaling_factor);
 }/*}}}*/
-/*FUNCTION ControlInput::SetGradient{{{*/
-void ControlInput::SetGradient(Input* gradient_in){
+void ControlInput::SetGradient(Input* gradient_in){/*{{{*/
 
 	/*Get enum for current gradient*/
@@ -185,6 +167,5 @@
 
 }/*}}}*/
-/*FUNCTION ControlInput::SetInput{{{*/
-void ControlInput::SetInput(Input* in_input){
+void ControlInput::SetInput(Input* in_input){/*{{{*/
 
 	delete values; this->values=in_input;
@@ -192,18 +173,14 @@
 
 }/*}}}*/
-/*FUNCTION ControlInput::SpawnTriaInput{{{*/
-Input* ControlInput::SpawnTriaInput(int index1,int index2,int index3){
+Input* ControlInput::SpawnTriaInput(int index1,int index2,int index3){/*{{{*/
 	return values->SpawnTriaInput(index1,index2,index3);
 }/*}}}*/
-/*FUNCTION ControlInput::SpawnSegInput{{{*/
-Input* ControlInput::SpawnSegInput(int index1,int index2){
+Input* ControlInput::SpawnSegInput(int index1,int index2){/*{{{*/
 	return values->SpawnSegInput(index1,index2);
 }/*}}}*/
-/*FUNCTION ControlInput::GetVectorFromInputs(Vector<IssmDouble>* vector,int* doflist){{{*/
-void ControlInput::GetVectorFromInputs(Vector<IssmDouble>* vector,int* doflist){
+void ControlInput::GetVectorFromInputs(Vector<IssmDouble>* vector,int* doflist){/*{{{*/
 	values->GetVectorFromInputs(vector,doflist);
 }/*}}}*/
-/*FUNCTION ControlInput::GetVectorFromInputs(Vector<IssmDouble>* vector,int* doflist,const char* data){{{*/
-void ControlInput::GetVectorFromInputs(Vector<IssmDouble>* vector,int* doflist,const char* data){
+void ControlInput::GetVectorFromInputs(Vector<IssmDouble>* vector,int* doflist,const char* data){/*{{{*/
 	 if(strcmp(data,"value")==0){
 		 _assert_(values);
@@ -226,34 +203,32 @@
 	 }
 }/*}}}*/
-/*FUNCTION ControlInput::GetInputAverage(IssmDouble* pvalue){{{*/
-void ControlInput::GetInputAverage(IssmDouble* pvalue){
+void ControlInput::GetInputAverage(IssmDouble* pvalue){/*{{{*/
 	values->GetInputAverage(pvalue);
 }/*}}}*/
-/*FUNCTION ControlInput::GetInputValue(bool* pvalue){{{*/
-void ControlInput::GetInputValue(bool* pvalue){
+void ControlInput::GetInputValue(bool* pvalue){/*{{{*/
 	values->GetInputValue(pvalue);
 }/*}}}*/
-/*FUNCTION ControlInput::GetInputValue(int* pvalue){{{*/
-void ControlInput::GetInputValue(int* pvalue){
+void ControlInput::GetInputValue(int* pvalue){/*{{{*/
 	values->GetInputValue(pvalue);
 }/*}}}*/
-/*FUNCTION ControlInput::GetInputValue(IssmDouble* pvalue){{{*/
-void ControlInput::GetInputValue(IssmDouble* pvalue){
+void ControlInput::GetInputValue(IssmDouble* pvalue){/*{{{*/
 	values->GetInputValue(pvalue);
 }/*}}}*/
-/*FUNCTION ControlInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){{{*/
-void ControlInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){
+void ControlInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss){/*{{{*/
 	values->GetInputValue(pvalue,gauss);
 }/*}}}*/
-/*FUNCTION ControlInput::GetGradientValue{{{*/
-void ControlInput::GetGradientValue(IssmDouble* pvalue,Gauss* gauss){
+void ControlInput::GetGradientValue(IssmDouble* pvalue,Gauss* gauss){/*{{{*/
 	gradient->GetInputValue(pvalue,gauss);
 }/*}}}*/
-/*FUNCTION ControlInput::GetInputDerivativeValue(IssmDouble* derivativevalues, IssmDouble* xyz_list, Gauss* gauss){{{*/
-void ControlInput::GetInputDerivativeValue(IssmDouble* derivativevalues, IssmDouble* xyz_list, Gauss* gauss){
+void ControlInput::GetInputDerivativeValue(IssmDouble* derivativevalues, IssmDouble* xyz_list, Gauss* gauss){/*{{{*/
 	values->GetInputDerivativeValue(derivativevalues,xyz_list,gauss);
 }/*}}}*/
-/*FUNCTION ControlInput::SaveValue{{{*/
-void ControlInput::SaveValue(void){
+IssmDouble ControlInput::Min(void){/*{{{*/
+
+	return values->Min();
+
+}
+/*}}}*/
+void ControlInput::SaveValue(void){/*{{{*/
 	if(!values) _error_("Values of " << EnumToStringx(this->enum_type) << " not found");
 
@@ -261,6 +236,5 @@
 	this->savedvalues=dynamic_cast<Input*>(this->values->copy());
 }/*}}}*/
-/*FUNCTION ControlInput::UpdateValue{{{*/
-void ControlInput::UpdateValue(IssmDouble scalar){
+void ControlInput::UpdateValue(IssmDouble scalar){/*{{{*/
 	if(!gradient)    _error_("Gradient of " << EnumToStringx(this->enum_type) << " not found");
 	if(!savedvalues) _error_("Values of " << EnumToStringx(this->enum_type) << " not found");
@@ -270,10 +244,8 @@
 	this->values->AXPY(gradient,scalar);
 }/*}}}*/
-/*FUNCTION ControlInput::VerticallyIntegrate{{{*/
-void ControlInput::VerticallyIntegrate(Input* thickness_input){
+void ControlInput::VerticallyIntegrate(Input* thickness_input){/*{{{*/
 	values->VerticallyIntegrate(thickness_input);
 }/*}}}*/
-/*FUNCTION ControlInput::Configure{{{*/
-void ControlInput::Configure(Parameters* parameters){
+void ControlInput::Configure(Parameters* parameters){/*{{{*/
 	/*do nothing: */
 }
Index: issm/trunk/src/c/classes/Inputs/ControlInput.h
===================================================================
--- issm/trunk/src/c/classes/Inputs/ControlInput.h	(revision 18081)
+++ issm/trunk/src/c/classes/Inputs/ControlInput.h	(revision 18301)
@@ -70,5 +70,5 @@
 		IssmDouble Max(void){_error_("not implemented yet");};
 		IssmDouble MaxAbs(void){_error_("not implemented yet");};
-		IssmDouble Min(void){_error_("not implemented yet");};
+		IssmDouble Min(void);
 		IssmDouble MinAbs(void){_error_("not implemented yet");};
 		void Extrude(void);
Index: issm/trunk/src/c/classes/Inputs/DatasetInput.cpp
===================================================================
--- issm/trunk/src/c/classes/Inputs/DatasetInput.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Inputs/DatasetInput.cpp	(revision 18301)
@@ -14,6 +14,5 @@
 
 /*DatasetInput constructors and destructor*/
-/*FUNCTION DatasetInput::DatasetInput(){{{*/
-DatasetInput::DatasetInput(){
+DatasetInput::DatasetInput(){/*{{{*/
 	enum_type = UNDEF;
 	inputs    = NULL;
@@ -22,6 +21,5 @@
 }
 /*}}}*/
-/*FUNCTION DatasetInput::DatasetInput(int in_enum_type,int* idlist,int numids) {{{*/
-DatasetInput::DatasetInput(int in_enum_type){
+DatasetInput::DatasetInput(int in_enum_type){/*{{{*/
 
 	enum_type = in_enum_type;
@@ -31,6 +29,5 @@
 }
 /*}}}*/
-/*FUNCTION DatasetInput::~DatasetInput(){{{*/
-DatasetInput::~DatasetInput(){
+DatasetInput::~DatasetInput(){/*{{{*/
 	xDelete<int>(this->ids);
 	delete inputs;
@@ -39,11 +36,9 @@
 
 /*Object virtual functions definitions:*/
-		/*FUNCTION DatasetInput::Echo {{{*/
-void DatasetInput::Echo(void){
+void DatasetInput::Echo(void){/*{{{*/
 	this->DeepEcho();
 }
 /*}}}*/
-/*FUNCTION DatasetInput::DeepEcho{{{*/
-void DatasetInput::DeepEcho(void){
+void DatasetInput::DeepEcho(void){/*{{{*/
 
 	_printf_("DatasetInput:\n");
@@ -56,9 +51,7 @@
 }
 /*}}}*/
-/*FUNCTION DatasetInput::Id{{{*/
-int    DatasetInput::Id(void){ return -1; }
+int    DatasetInput::Id(void){ return -1; }/*{{{*/
 /*}}}*/
-/*FUNCTION DatasetInput::ObjectEnum{{{*/
-int DatasetInput::ObjectEnum(void){
+int DatasetInput::ObjectEnum(void){/*{{{*/
 
 	return DatasetInputEnum;
@@ -66,6 +59,5 @@
 }
 /*}}}*/
-/*FUNCTION DatasetInput::copy{{{*/
-Object* DatasetInput::copy() {
+Object* DatasetInput::copy() {/*{{{*/
 
 	DatasetInput* output=NULL;
@@ -73,11 +65,13 @@
 	output = new DatasetInput();
 	output->enum_type=this->enum_type;
-	output->inputs=(Inputs*)this->inputs->Copy();
+	output->numids=this->numids;
+	output->ids=xNew<int>(output->numids);
+	xMemCpy(output->ids,this->ids,output->numids);
+	output->inputs=static_cast<Inputs*>(this->inputs->Copy());
 
-	return output;
+	return (Object*)output;
 }
 /*}}}*/
-/*FUNCTION DatasetInput::SpawnTriaInput{{{*/
-Input* DatasetInput::SpawnTriaInput(int index1,int index2,int index3){
+Input* DatasetInput::SpawnTriaInput(int index1,int index2,int index3){/*{{{*/
 
 	/*output*/
@@ -96,6 +90,5 @@
 }
 /*}}}*/
-/*FUNCTION DatasetInput::SpawnSegInput{{{*/
-Input* DatasetInput::SpawnSegInput(int index1,int index2){
+Input* DatasetInput::SpawnSegInput(int index1,int index2){/*{{{*/
 
 	/*output*/
@@ -116,6 +109,5 @@
 
 /*DatasetInput management*/
-/*FUNCTION DatasetInput::AddInput{{{*/
-void DatasetInput::AddInput(Input* input,int id){
+void DatasetInput::AddInput(Input* input,int id){/*{{{*/
 
 	_assert_(this->numids == this->inputs->Size());
@@ -144,6 +136,5 @@
 }
 /*}}}*/
-/*FUNCTION DatasetInput::InstanceEnum{{{*/
-int DatasetInput::InstanceEnum(void){
+int DatasetInput::InstanceEnum(void){/*{{{*/
 
 	return this->enum_type;
@@ -153,11 +144,9 @@
 
 /*Object functions*/
-/*FUNCTION DatasetInput::Configure{{{*/
-void DatasetInput::Configure(Parameters* parameters){
+void DatasetInput::Configure(Parameters* parameters){/*{{{*/
 	/*do nothing: */
 }
 /*}}}*/
-/*FUNCTION DatasetInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss,int id){{{*/
-void DatasetInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss,int id){
+void DatasetInput::GetInputValue(IssmDouble* pvalue,Gauss* gauss,int id){/*{{{*/
 
 	int  offset = -1;
@@ -166,5 +155,5 @@
 	/*Get requested input within dataset*/
 	for(int i=0;i<this->numids;i++) if(this->ids[i]==id) offset=i;
-	if(offset<0) _error_("Could not find input of id "<<id);
+	if(offset<0) _error_("Could not find input of id "<<id );
 
 	Input* input=dynamic_cast<Input*>(this->inputs->GetObjectByOffset(offset));
